/*
*
*   Amx Paint v1.5
*         by Genesis
*
* 
* 
*
*     Additional Help/ Coding Provided by Twilight Suzuka
*     Additional Concepts Provided by Johnny Got His Gun
*/

#include <amxmodx>
#include <amxmisc>
#include <engine>

new paint
new lastKnownCord[33][3]
new lightning_model

public plugin_init()
{
	register_plugin("Paint","1.5","Genesis")
	register_concmd("paint","draw",ADMIN_LEVEL_C,"paint <red>, <green>, <blue>  -- just dots")
	register_concmd("paint2","draw2",ADMIN_LEVEL_C,"paint2 <red>, <green>, <blue> -- dots that connect")
	register_concmd("clearpaint","flush",ADMIN_LEVEL_C,"clears all dots associated with amx_paint")
	register_concmd("stopline","stopconnect",ADMIN_LEVEL_C,"amx_paint >> stop connection between dots")
	register_cvar("paint_limit","50")
	paint = 0;
}

public draw(id, level, cid)
{
	if (!cmd_access(id,level,cid,0)) 
		return PLUGIN_HANDLED

	if(paint > get_cvar_num("paint_limit") ) 
		return PLUGIN_HANDLED

	new arg[32]
	new Float:Vec[3]
	new r, g, b

	read_argv(1,arg,31)
	if(arg[0] == 'x' || arg[0] == 'X')
	{
		r = 0
	}
	else
	{
		r = str_to_num(arg)
		if(!r) 
			r = random_num(0,255)
	}

	read_argv(2,arg,31)
	if(arg[0] == 'x' || arg[0] == 'X')
	{
		g = 0
	}
	else
	{
		g = str_to_num(arg)
		if(!g) 
			g = random_num(0,255)
	}

	read_argv(3,arg,31)
	if(arg[0] == 'x' || arg[0] == 'X')
	{
		b = 0
	}
	else
	{
		b = str_to_num(arg)
		if(!b) 
			b = random_num(0,255)
	}

	new endpoint[3]
	get_user_origin(id, endpoint, 3)

	new entid = create_entity("info_target")
	if(!entid) 
		return PLUGIN_HANDLED;

	entity_set_string(entid, EV_SZ_classname, "paint_dot")
	entity_set_edict(entid, EV_ENT_owner, id)
	entity_set_int(entid, EV_INT_movetype, MOVETYPE_NONE)
	entity_set_int(entid, EV_INT_solid, SOLID_NOT)
	set_rendering(entid, kRenderFxNoDissipation, r, g, b, kRenderGlow, 255)
	entity_set_model(entid, "sprites/dot.spr")
	IVecFVec(endpoint, Vec)
	entity_set_origin(entid, Vec)

	paint++;
	return PLUGIN_HANDLED
}

public draw2(id, level, cid)
{
	if (!cmd_access(id,level,cid,0)) 
		return PLUGIN_HANDLED

	if(paint > get_cvar_num("paint_limit") ) 
		return PLUGIN_HANDLED;

	new arg[32]
	new Float:Vec[3]
	new r, g, b

	read_argv(1,arg,31)
	if(arg[0] == 'x' || arg[0] == 'X')
	{
		r = 0
	}
	else
	{
		r = str_to_num(arg)
		if(!r) 
			r = random_num(0,255)
	}

	read_argv(2,arg,31)
	if(arg[0] == 'x' || arg[0] == 'X')
	{
		g = 0
	}
	else
	{
		g = str_to_num(arg)
		if(!g) 
			g = random_num(0,255)
	}

	read_argv(3,arg,31)
	if(arg[0] == 'x' || arg[0] == 'X')
	{
		b = 0
	}
	else
	{
		b = str_to_num(arg)
		if(!b) 
			b = random_num(0,255)
	}

	new endpoint[3]
	get_user_origin(id, endpoint, 3)

	new entid = create_entity("info_target")
	if(!entid) 
		return PLUGIN_HANDLED;

	entity_set_string(entid, EV_SZ_classname, "paint_dot")
	entity_set_edict(entid, EV_ENT_owner, id)
	entity_set_int(entid, EV_INT_movetype, MOVETYPE_NONE)
	entity_set_int(entid, EV_INT_solid, SOLID_NOT)
	set_rendering(entid, kRenderFxNoDissipation, r, g, b, kRenderGlow, 255)
	entity_set_model(entid, "sprites/dot.spr")
	IVecFVec(endpoint, Vec)
	entity_set_origin(entid, Vec)

	paint++;

	if(lastKnownCord[id][0] == 0)
	{
		if(lastKnownCord[id][0] == 0)
		{
			if(lastKnownCord[id][0] == 0)
			{
				lastKnownCord[id][0] = endpoint[0]
				lastKnownCord[id][1] = endpoint[1]
				lastKnownCord[id][2] = endpoint[2]
				return PLUGIN_HANDLED
			}
		}
	}
	
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY) 
	write_byte ( 0 )     //TE_BEAMPOINTS 0
	write_coord (endpoint[0])
	write_coord (endpoint[1])
	write_coord (endpoint[2])
	write_coord (lastKnownCord[id][0])
	write_coord (lastKnownCord[id][1])
	write_coord (lastKnownCord[id][2])
	write_short(lightning_model)
	write_byte (0)       // start frame 
	write_byte (15)      // frame rate in 0.1's 
	write_byte (0)     // byte (life in 0.1's 
	write_byte (20)      // line width in 0.1's
	write_byte (5)      // noise amplitude in 0.01's 
	write_byte (r)       // RGB color
	write_byte (g)
	write_byte (b)
	write_byte (255)     // brightness
	write_byte (10)      // scroll speed in 0.1's
	message_end() 
	
	lastKnownCord[id][0] = endpoint[0]
	lastKnownCord[id][1] = endpoint[1]
	lastKnownCord[id][2] = endpoint[2]

	return PLUGIN_HANDLED
}

public flush(id, level, cid)
{
	if (!cmd_access(id,level,cid,0)) 
		return PLUGIN_HANDLED

	new arg[32]
	read_argv(1,arg,31)
	new ownerid = str_to_num(arg)
	
	if(!ownerid)
	{
		remove_entity_name("paint_dot")
		paint = 0;
	}
	else 
	{
		remove_by_owner(ownerid,"paint_dot")
	}
	
	return PLUGIN_HANDLED
}


public remove_by_owner(id,classname[])
{
	new iEntity = find_ent_by_owner ( -1, classname, id, 0 )
	while (iEntity > 0)
	{
		paint--;
		remove_entity(iEntity)
		iEntity = find_ent_by_class(-1, classname)
	}
	return 1;
}

public stopconnect(id, level, cid)
{
	if (!cmd_access(id,level,cid,0))
		return PLUGIN_HANDLED

	lastKnownCord[id][0] = 0
	lastKnownCord[id][1] = 0
	lastKnownCord[id][2] = 0
	return PLUGIN_HANDLED
}

public plugin_precache()
{
	precache_model("sprites/dot.spr")
	lightning_model = precache_model("sprites/lgtning.spr")
}